// Start of Code //

/* 
* Automatic Fish Feeder using separate timer plug; 
* Number-of-sweeps is set in the loop; 
* Update to v3.1 with different speed and more pellets drop; 
* chienline @2014; 
*/ 

#include <Stepper.h>
#define STEPS 100 

Stepper stepper(STEPS, 8, 9, 10, 11); 
const int switchPin = 2; 
const int ledPin = 13; 
int val = 80; //how wide the door open; 
int fullSweep = 0; 
int properlyClosed = 0; 
int numberOfSweeps = 0; // this is sweep counter; setting is in the loop; 

void setup() { 
	pinMode(switchPin,INPUT);
	pinMode(ledPin,OUTPUT);
	digitalWrite(ledPin, LOW);
	delay(5000);
} 

void loop() {
	if (numberOfSweeps < 2){ // set how many sweeps here;
	if (!fullSweep){
	//slower when opening to drop more pellets;
	stepper.setSpeed(80);
	stepper.step(-val);
	//faster when closing to reduce lid jam;
	stepper.setSpeed(100);
	stepper.step(val+1); 
	
	// checks if the lid is properly closed;
	if (digitalRead(switchPin)==HIGH){
	properlyClosed = 1;
	digitalWrite(ledPin, HIGH);
	fullSweep = 1;
	}
	else{
	while(!properlyClosed){
	// moves backward a little to release stuck food
	// then moves forward;
	stepper.step(-15);
	stepper.step(50);
	if (digitalRead(switchPin)==HIGH){
	properlyClosed = 1;
	digitalWrite(ledPin, HIGH);
	fullSweep = 1;
	}
	}
	}
	numberOfSweeps++;
	fullSweep = 0;
	properlyClosed = 0;
	}
	}
}

// End of Code //